package com.mprj.portlet.navegvertical;

import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.portlet.LiferayPortlet;
import com.liferay.portal.kernel.servlet.HttpHeaders;
import com.liferay.portal.kernel.util.Http;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.Validator;
import com.liferay.portal.kernel.util.WebKeys;
import com.liferay.portal.model.Layout;
import com.liferay.portal.model.LayoutConstants;
import com.liferay.portal.security.permission.ActionKeys;
import com.liferay.portal.service.GroupLocalServiceUtil;
import com.liferay.portal.service.LayoutLocalServiceUtil;
import com.liferay.portal.service.permission.LayoutPermissionUtil;
import com.liferay.portal.theme.ThemeDisplay;
import com.liferay.portal.util.PortalUtil;
import com.mprj.portlet.navegvertical.modelo.Pagina;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.PortletException;
import javax.portlet.PortletRequest;
import javax.portlet.PortletRequestDispatcher;
import javax.portlet.PortletSession;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
import javax.servlet.http.HttpServletRequest;

public class NavegVerticalPortlet extends LiferayPortlet {
	private String viewJSP;
	private String editJSP;
	private final Log log = LogFactoryUtil.getLog(NavegVerticalPortlet.class);
	/**
	 * definio do ltimo nvel a ser exibido no menu
	 */
	private static final int NIVEL_MAXIMO = 2; 
	private static final int NIVEL_INICIAL = 1;
	/**
	 * nome do atributo de	sesso contendo	o objeto Layout que representa o root sendo exibido atualmente
	 */
	private static final String NOME_SESSAO_LAYOUT = "NAVEG_VERTICAL_LAYOUT_SHOWING";
	private static final String LAYOUT_CONSULTA_KEY = "layout-template-id";
	private static final String LAYOUT_CONSULTA_ID = "layout_mprj_consultas";

	private static final String CONSTANTE_SLASH = "/";
	
	/**
	 * Nome do atributo do campo customizvel referente a exibio do submenu da pgina quando esta est sendo exibida no nvel 1.
	 */
	private static final String ATRIBUTO_EXIBIR_SUBMENU = "exibir-item-pai";
	
	/**
     * Nome do atributo do campo customizvel referente a exibio do banner.
     */
    private static final String ATRIBUTO_EXIBIR_BANNER = "exibir-banner";
    
    /**
     * Nome do atributo do campo customizvel referente a exibio do menu.
     */
    private static final String ATRIBUTO_LINK_MENU_PAGINA = "menu-pagina";
    
    /**
     * Nome do atributo do campo customizvel referente a exibio do menu.
     */
    private static final String ATRIBUTO_EXIBIR_TITULO = "exibir-nome-da-pagina-no-menu";
    
    
	/**
	 * Nome do atributo do campo customizvel que ser utilizado para definir o title da tag <a> referente a pgina no menu vertical.
	 */
	private static final String ATRIBUTO_TITLE_MENU = "titulo-html-menu";
	
	/**
	 * Nome do atributo do campo para desativar a funcionalidade do link pai.
	 */
	private static final String ATRIBUTO_DESATIVAR_LINK_PAI = "desativar-link";
	private static final String HREF_DESATIVADO = "#";

	private static final String MSG_ERRO_MENU = "No foi possvel montar o menu... ";
	
	private static final String HOST_CACHE = "www.tjrj.jus.br";
	
	/**
	 * URL a ser utilizado para os links relativos que so acessados atravs de importao dos sistemas.
	 * Ticket: #51366.
	 */
	private static final String URL_PADRAO = Http.HTTP_WITH_SLASH.concat(HOST_CACHE);
	
	private static final String NOME_EHCACHE = "NavegVerticalPortlet";
	
//	private Ehcache cache;
//	
	public void init() throws PortletException {
		this.viewJSP = getInitParameter("view-jsp");
		this.editJSP = getInitParameter("edit-jsp");
//		try {
//			CacheManager cm = CacheManager.getInstance(); 
//			cache = cm.getCache(NOME_EHCACHE);
//			if (cache == null) {
//				cache = cm.addCacheIfAbsent(NOME_EHCACHE);
//			}
//			MBeanServer mbean = ManagementFactory.getPlatformMBeanServer();
//			//http://www.ehcache.org/documentation/user-guide/jmx
//			ManagementService.registerMBeans(cm, mbean, false, false, true, true);
//		}
//		catch (Exception ex) {
//			log.error("Problemas ao criar o cache:", ex);
//		}
	}

	public void processAction(ActionRequest request, ActionResponse response) {
	}

//	public void doView(RenderRequest req, RenderResponse renderResponse) throws IOException, PortletException {
//		String menu = null;
//		try {
//			if (PortalUtil.getHost(req).equals(HOST_CACHE) && cache != null) {
//				Layout layout = ((Layout) req.getAttribute(WebKeys.LAYOUT)); 
//				String url = layout.getGroup().getFriendlyURL().concat(layout.getFriendlyURL());
//				Element element = cache.get(url);
//				if (element != null) {
//					menu = (String)element.getObjectValue();
//				}
//				else {
//					menu = getMenuMontado(req);
//					cache.put(new Element(url, menu));
//				}
//			}
//			else {
//				menu = getMenuMontado(req);
//			}
//		}
//		catch (Exception ex) {
//			log.error("Problemas ao carregar menu do cache:", ex);
//			menu = getMenuMontado(req);
//		}
//		req.setAttribute(Atributo.NAVEG_VERTICAL_PAGINAS, menu);
//		include(this.viewJSP, req, renderResponse);
//	}
	public void doView(RenderRequest req, RenderResponse renderResponse) throws IOException, PortletException {
		String menu = null;
		try {
			menu = getMenuMontado(req);
		}
		catch (Exception ex) {
			log.error("Problemas ao carregar menu do cache:", ex);
			menu = getMenuMontado(req);
		}
		req.setAttribute(Atributo.NAVEG_VERTICAL_PAGINAS, menu);
		include(this.viewJSP, req, renderResponse);
	}
	
	private String getMenuMontado(RenderRequest req) {
		Pagina pagina = listarSubPaginas(req, true, false);
		return montarMenu(pagina);		
	}

	public void doEdit(RenderRequest renderRequest, RenderResponse renderResponse) throws IOException, PortletException {
		include(this.editJSP, renderRequest, renderResponse);
	}

	protected void include(String path, RenderRequest renderRequest, RenderResponse renderResponse) throws IOException, PortletException {
		PortletRequestDispatcher portletRequestDispatcher = getPortletContext().getRequestDispatcher(path);

		if (portletRequestDispatcher == null) {
			log.error(path + " is not a valid include");
		} else {
			portletRequestDispatcher.include(renderRequest, renderResponse);
		}
	}

	private Pagina listarSubPaginas(PortletRequest req, boolean utilizarPermissao, boolean importacao) {
		Layout rootLayout = (Layout) req.getAttribute(WebKeys.LAYOUT);
		return listarSubPaginas(req, rootLayout, utilizarPermissao, importacao);
	}

	private String montarMenu(Pagina pagina) {
		//capacidade inicial em 50 itens
		StringBundler menu = new StringBundler(50);

		menu.append(Atributo.DIV_NAVEG_VERTICAL);
		
		
		menu.append(Atributo.DIV_TITULO);
		if(pagina.isExibirTitulo()){
			menu.append(pagina.getNome());
		}
		menu.append(Atributo.DIV_FECHAMENTO_TAG);
	
		menu.append(Atributo.UL_LAYOUTS_LEVEL);
		menu.append(NIVEL_INICIAL);
		menu.append(Atributo.ASPAS_DUPLAS.concat(Atributo.FECHAMENTO_TAG));
		montarSubMenu(pagina.getFilhas(), menu);
		menu.append(Atributo.UL_FECHAMENTO_TAG);

		menu.append(Atributo.DIV_FECHAMENTO_TAG);

		return menu.toString();
	}

	private void montarSubMenu(List<Pagina> listFilhas, StringBundler menu) {
		if (listFilhas == null) {
			return;
		}
		int qtdFilhas = listFilhas.size();
		int indFilha = NIVEL_INICIAL;
		for (Pagina filha : listFilhas) {
			//definir se  ou no para definir menu expansvel (accordion)
			//boolean isExpand = filha.isAberto();
			boolean isExpand = filha.isExibirFilhosNivel1();
			boolean exibirBanner = filha.isExibirBanner();
			String imagemBanner = "/image/layout_icon?img_id="+filha.getImagemBanner();
			
			//Verificar se tem filhas e se  pra mostra o item como pai
            if (filha.getFilhas() != null && isExpand) {
                
                menu.append(Atributo.DIV_TITULO);
                menu.append(filha.getNome());
                menu.append(Atributo.DIV_FECHAMENTO_TAG);
                
                menu.append(Atributo.UL_LAYOUTS_LEVEL);
                menu.append(NIVEL_INICIAL);
                menu.append(Atributo.ASPAS_DUPLAS.concat(Atributo.FECHAMENTO_TAG));
                montarSubMenu(filha.getFilhas(), menu);
                menu.append(Atributo.UL_FECHAMENTO_TAG);
                
                
              }else
              {
        			menu.append(Atributo.LI_LAYOUTS_LEVEL);
        			menu.append(filha.getNivel());
        			
        			if (filha.isSelecionado()) {
        				menu.append(Atributo.MENU_SELECTED);
        			}
        			
        			if (indFilha == qtdFilhas) {
        				menu.append(Atributo.ITEM_MENU_ULTIMO);
        			}
        			
        			StringBundler className = new StringBundler(1);
        
        			if (isExpand) {
        				className.append(Atributo.MENU_OPEN);
        			}
        
        			if (filha.isSelecionado()) {
        				className.append(Atributo.MENU_SELECTED);
        			}
        
        			if (filha.isExpandido()) {
        				className.append(Atributo.MENU_EXPANDED);
        			}
        
        			if (Validator.isNotNull(className)) {
        				menu.append(className.toString());
        			}
        			
        			menu.append(Atributo.ASPAS_DUPLAS);
        			
        			menu.append(Atributo.FECHAMENTO_TAG);
        
        			// divs para centralizacao vertical do texto devido a
        			// compatibilidade com navegadores,
        			// e tambm para montagem da imagem em 3 partes: superior, meio
        			// (onde pode ter repeat-y) e inferior.
        			
        			if(exibirBanner) {
        				menu.append(Atributo.DIV_BANNER);
        			} else {
        				menu.append(Atributo.DIV_CONTEUDO);
        			}
        			
        			if (Validator.isNotNull(className)) {
        				menu.append(className.toString());
        			}
        			
        			menu.append(Atributo.ASPAS_DUPLAS.concat(Atributo.FECHAMENTO_TAG));	
        
        			menu.append(Atributo.A_ABERTURA_TAG);
        
        			menu.append(Atributo.HREF);
        			if (!filha.isDesativarLink()) {
        				menu.append(filha.getHref());
        			}
        			else {
        				menu.append(HREF_DESATIVADO);
        			}
        			
			
	              menu.append(Atributo.ASPAS_DUPLAS.concat(Atributo.ESPACO));
	              menu.append(filha.getTarget());
	              adicionarTituloMenu(menu, filha, isExpand, false);
	              
	              if(exibirBanner){
	                  menu.append( Atributo.A_BANNER_CLASS );
	                  }
	              
	              menu.append(Atributo.FECHAMENTO_TAG);
	              
	              
	              if(exibirBanner){
	                  menu.append( Atributo.IMG_ABERTURA_TAG.concat( Atributo.ASPAS_DUPLAS ) );
	                  menu.append( imagemBanner );
	                  menu.append( Atributo.ASPAS_DUPLAS );
	                  menu.append( Atributo.IMG_FECHAMENTO_TAG );
	                  
	              }
	              else{
	                  menu.append(filha.getNome());
	              }
	              
	              menu.append(Atributo.A_FECHAMENTO_TAG);
	          }
            
			
			
			menu.append(Atributo.LI_FECHAMENTO_TAG); //fechamento do LAYOUTS-LEVEL
			
			indFilha++;
		}
	}
	
	/**
	 * Adicionar o title ao link (&lt;a&gt;) da pgina informada no parmetro.
	 * @param menu
	 * @param pagina
	 * @param isExpand - boolean indicando se deve utilizar formatao para expandir/recolher menu.
	 * @param isIcone - boolean indicando se  link que representa o cone do menu.
	 */
	private void adicionarTituloMenu(StringBundler menu, Pagina pagina, boolean isExpand, boolean isIcone) {
		//verificar se tem ttulo personalizado (definido no gerenciamento de pginas)
		String title = pagina.getTitulo();
		if (title != null 
				&& !title.equals(StringPool.BLANK)) {
			definirTitle(menu, title, isExpand, isIcone);
		}
		else if (isExpand) {
			definirTitle(menu, pagina.getNome(), isExpand, isIcone);
		}
	}
	
	/**
	 * Define o title do link (aps passar por verifica no mtodo adicionarTituloMenu.
	 * @param menu
	 * @param inicioTitle - texto inicial do ttulo.
	 * @param isExpand - boolean indicando se deve utilizar formatao para expandir/recolher menu.
	 * @param isIcone - boolean indicando se  link que representa o cone do menu.
	 */
	private void definirTitle(StringBundler menu, String inicioTitle, boolean isExpand, boolean isIcone) {
		menu.append(Atributo.ESPACO);
		menu.append(Atributo.TITLE);
		menu.append(inicioTitle);
		if (!isIcone) {
			menu.append(Atributo.MENU_TITLE_ACCORDION);
		}
		else {
			menu.append(Atributo.MENU_TITLE_ACCORDION_ICONE);
		}
		menu.append(Atributo.ASPAS_DUPLAS);		
	}

	public void serveResource(ResourceRequest req, ResourceResponse res) throws PortletException {
		ThemeDisplay themeDisplay = getThemedisDisplay(req);

		long groupId = themeDisplay.getLayout().getGroupId();

		// identificador do recurso
		PrintWriter pw = null;
		String menuId = req.getParameter(Atributo.PARAMETRO_MENU_ID);
		try {
			pw = res.getWriter();

			// String resourceId = req.getResourceID();
			res.setContentType(Atributo.CONTENT_TYPE_HTML);
			res.setCharacterEncoding(Atributo.CHARSET_UTF_8);
			
			//parmetro com informao da origem do acesso: I = Intranet, W = Internet (Web)
			String origemAcesso = req.getParameter(Atributo.PARAMETRO_ORIGEM_ACESSO);
			//se o parmetro for null, ou o parmetro no for I (Intranet), utilizar a segurena
			boolean utilizarSeguranca = !(origemAcesso != null && origemAcesso.equals(Atributo.PARAMETRO_ORIGEM_INTRANET));
			
			Layout rootLayout = LayoutLocalServiceUtil.getFriendlyURLLayout(groupId, false, menuId);
			
			Pagina pagina = listarSubPaginas(req, rootLayout, utilizarSeguranca, true);
			
			String html = montarMenu(pagina); 
			
			pw.write(html);
			
			//Ticket #51366. O trecho abaixo foi feito com base no ETagUtil._processETag(HttpServletRequest request, HttpServletResponse response, int hashCode)
			String eTag = StringPool.QUOTE.concat(Integer.toHexString(html.hashCode())).concat(StringPool.QUOTE);
			PortalUtil.getHttpServletResponse(res).setHeader(HttpHeaders.ETAG, eTag);			

		} catch (Exception ex) {
			pw.write(MSG_ERRO_MENU);
			throw new PortletException(MSG_ERRO_MENU.concat(menuId), ex);
		} finally {
			if (pw != null) {
				pw.flush();
				pw.close();
			}
		}
	}

	/**
	 * Retornar o theme display que est no atributo da requisio.
	 * @param req
	 * @return ThemeDisplay
	 */
	private ThemeDisplay getThemedisDisplay(PortletRequest req) {
		// recuperar o theme display corrente
		return (ThemeDisplay) req.getAttribute(WebKeys.THEME_DISPLAY); 
	}

	private Pagina listarSubPaginas(PortletRequest req, Layout rootLayout, boolean utilizarPermissao, boolean importacao) {
		Pagina pagina = new Pagina();
		String grupo="";
		try {
			HttpServletRequest request = (HttpServletRequest) req.getAttribute(Atributo.PORTLET_SERVLET_REQUEST);
			ThemeDisplay themeDisplay = (ThemeDisplay) req.getAttribute(WebKeys.THEME_DISPLAY);
			
			String linkMenu = getLinkMenuPagina(rootLayout);
			String fiendlyUrl = GroupLocalServiceUtil.getGroup(themeDisplay.getParentGroupId()).getFriendlyURL();
			grupo = themeDisplay.getPathFriendlyURLPublic()+fiendlyUrl;
			
			if(linkMenu!=null && linkMenu!=""){
				long plid = PortalUtil.getPlidFromFriendlyURL(themeDisplay.getCompanyId(), grupo+linkMenu);
				rootLayout =  LayoutLocalServiceUtil.getLayout(plid);
			}
			
			Layout selLayout = rootLayout; // definir o layout atual
			List ancestors = rootLayout.getAncestors();

			PortletSession portletSession = req.getPortletSession();
			Layout layoutShow = (Layout) portletSession.getAttribute(NOME_SESSAO_LAYOUT, PortletSession.APPLICATION_SCOPE);

			// verificar se est no ltimo nvel da hieraquia
			// se estiver, utilizar o n pai como principal na montagem da
			// navegao
			if (getChildrenVisible(getChildrenPermissao(themeDisplay, rootLayout, utilizarPermissao)).size() == 0
					&& ancestors != null 
					&& ancestors.size() > 0) {
				int idAncestor = ancestors.size() > 1 ? 1 : 0;
				Layout pai = null;
				Layout ancestorRoot = (Layout) ancestors.get(idAncestor);
				if (idAncestor > 0) {
					pai = (Layout) ancestors.get(0);
				}

				// caso o ancestor (root) definido no contenha como
				// filho o pai da pgina atual,
				// definir como root o pai, caso contrrio manter o root
				// definido anteriormente.
				// verificar tambm se o root (showing) definido na
				// sesso, ou seja, o que est sendo exibido no momento,
				//  o pai na hieraquia das pginas, se for, definir o
				// pai como root no lugar do ancestor.				
				if (idAncestor >= 1 &&
						(!getChildrenVisible(getChildrenPermissao(themeDisplay, ancestorRoot, utilizarPermissao)).contains(pai) 
							|| pai.equals(layoutShow)
							|| layoutShow == null) && !getExibirSubMenu(pai)) {
					ancestorRoot = pai;
				}
				rootLayout = ancestorRoot;
			}
			portletSession.setAttribute(NOME_SESSAO_LAYOUT, rootLayout, PortletSession.APPLICATION_SCOPE);

			List<Layout> selBranch = new ArrayList<Layout>();
			selBranch.add(rootLayout);
			selBranch.addAll(rootLayout.getAncestors());

			pagina.setNome(rootLayout.getName(themeDisplay.getLocale()));
			pagina.setHref(getUrl(rootLayout.getRegularURL(request), themeDisplay, importacao));
			pagina.setExibirFilhosNivel1(getExibirSubMenu(rootLayout));
			pagina.setExibirBanner(getExibirBanner(rootLayout));
			pagina.setExibirTitulo(getExibirTitulo(rootLayout));
			pagina.setImagemBanner(getImagemBanner(rootLayout));
			pagina.setOcultarTitulo(ocultarTituloMenu(rootLayout));
			pagina.setTitulo(getTitleHtmlMenu(rootLayout));
			
			buildNavigation(rootLayout, selLayout, selBranch, themeDisplay, 1, Atributo.MENU_AUTO, true, pagina, utilizarPermissao, importacao);
			
		} catch (Exception se) {
			log.error("Problemas ao listar subpginas:", se);
		}
		return pagina;
	}

	private void buildNavigation(Layout rootLayout, Layout selLayout, List selBranch, 
								  ThemeDisplay themeDisplay, int layoutLevel, String includedLayouts,
								  boolean nestedChildren, Pagina pagina, boolean utilizarPermissao,
								  boolean importacao)
			throws SystemException, PortalException {
		//verificar se chegou ao nvel mximo para exibio de submenu ou se a pgina pai (parent) foi configurada para exibir submenus a partir do nvel 1.
		if (layoutLevel > NIVEL_MAXIMO 
				|| (!pagina.isExibirFilhosNivel1() && layoutLevel > 1)) {
			return;
		}

		List layoutChildren = null;

		if (rootLayout != null) {
			layoutChildren = getChildrenVisible(getChildrenPermissao(themeDisplay, rootLayout, utilizarPermissao));
		} else {
			layoutChildren = LayoutLocalServiceUtil.getLayouts(selLayout.getGroupId(), selLayout.isPrivateLayout(), LayoutConstants.DEFAULT_PARENT_LAYOUT_ID);
		}

		if (layoutChildren.size() > 0) {

			List<Pagina> listFilhas = new ArrayList<Pagina>();
			pagina.setFilhas(listFilhas);

			for (int i = 0; i < layoutChildren.size(); i++) {
				Layout layoutChild = (Layout) layoutChildren.get(i);

				Pagina filha = new Pagina();
				
				//verificar se a pgina no est oculta, se no est utilizando segurana, e se estiver usando segurana verificar se o usurio tem permisso.
				if (!layoutChild.isHidden() 
						&& (!utilizarPermissao 
								|| (utilizarPermissao && LayoutPermissionUtil.contains(themeDisplay.getPermissionChecker(), layoutChild, ActionKeys.VIEW)))) {
					String layoutURL = getUrl(PortalUtil.getLayoutURL(layoutChild, themeDisplay), themeDisplay, importacao);
					String target = PortalUtil.getLayoutTarget(layoutChild);

					boolean open = false;
					// definir se a pgina no lao atual possui como filho a
					// pgina selecionada, neste caso deve exibir o accordion
					// deste menu como expandido
					boolean expand = false;

					List<Layout> filhosTemp = getChildrenVisible(getChildrenPermissao(themeDisplay, layoutChild, utilizarPermissao));

					if (includedLayouts.equals(Atributo.MENU_AUTO) 
							&& (selBranch.contains(layoutChild) || (filhosTemp.size() > 0))) {

						if (layoutLevel < NIVEL_MAXIMO) {
							open = true;
						}

						// verificar se o item atual do lao possui como filho a
						// pgina atual, para exibi-lo como expandido no
						// accordion
						if (filhosTemp.size() > 0 && filhosTemp.contains(selLayout)) {
							expand = true;
						}

					}

					if (includedLayouts.equals(Atributo.MENU_ALL)) {
						open = true;
					}

					if (open) {
						filha.setAberto(true);
					}

					if (selLayout.getLayoutId() == layoutChild.getLayoutId()) {
						filha.setSelecionado(true);
					}

					if (expand) {
						filha.setExpandido(true);
					}

					filha.setHref(layoutURL);
					filha.setTarget(target);
					filha.setNome(layoutChild.getName(themeDisplay.getLocale()));
					filha.setNivel(layoutLevel);
					filha.setExibirFilhosNivel1(getExibirSubMenu(layoutChild));
					filha.setExibirBanner(getExibirTitulo(layoutChild));
					
					filha.setExibirBanner(getExibirBanner(layoutChild));
					filha.setImagemBanner(getImagemBanner(layoutChild));
					
					filha.setTitulo(getTitleHtmlMenu(layoutChild));
					filha.setDesativarLink(false);

					listFilhas.add(filha);

					if (open) {
						buildNavigation(layoutChild, selLayout, selBranch, themeDisplay, layoutLevel + 1, includedLayouts, nestedChildren, filha, utilizarPermissao, importacao);
					}
				}
			}
		}
		//definir se deve desativar/ativar o link do pai apenas se forem identificados filhos,
		//estiver no nvel 1 e estiver configurado para exibir os filhos deste ntvel.
		if (layoutChildren.size() > 0 && pagina.getNivel() == 1 && pagina.isExibirFilhosNivel1() && isDesativarLinkPai(rootLayout)) {
			pagina.setDesativarLink(true);
		}
		else {
			pagina.setDesativarLink(false);	
		}
		
	}
	
	/**
	 * Retorna a URL relativa ou absoluta caso seja importao.
	 * @param url
	 * @param themeDisplay
	 * @param importacao
	 * @return String
	 */
	private String getUrl(String url, ThemeDisplay themeDisplay, boolean importacao) {
		if (!importacao) {
			return url;
		}
		if (url != null) {
			//se for caminho relativo (inicia com /) utilizar a URL do portal como base.
			return (url.startsWith(CONSTANTE_SLASH) ? definirHostUrlRelativa(url, themeDisplay, importacao) : url);
		}
		return null;
	}
	
	/**
	 * Retorna a URL com o host concatenado para www caso seja importao, ou caso contrrio, mantm o host da requisio.
	 * Ticket # 
	 * @param url
	 * @param themeDisplay
	 * @param importacao
	 * @return String
	 */
	private String definirHostUrlRelativa(String url, ThemeDisplay themeDisplay, boolean importacao) {
		return (!importacao ? themeDisplay.getPortalURL().concat(url) : URL_PADRAO.concat(url));
	}
	
	/**
	 * Carrega o contedo do atributo customizado para a pgina (layout) em relao a exibir ou no o submenu da pgina atual quando esta estiver no nvel 1.
	 * @param layout
	 * @return boolean
	 */
	private boolean getExibirSubMenu(Layout layout) {
		Boolean exibir = (Boolean)layout.getExpandoBridge().getAttribute(ATRIBUTO_EXIBIR_SUBMENU);
		if (exibir != null) {
			return exibir;
		}
		return false;
	}
	
	/**
     * Carrega o contedo do atributo customizado para a pgina (layout) em relao a exibir ou no no submenu da pgina atual o Banner.
     * @param layout
     * @return boolean
     */
    private boolean getExibirBanner(Layout layout) {
        Boolean exibirBanner = (Boolean)layout.getExpandoBridge().getAttribute(ATRIBUTO_EXIBIR_BANNER);
        if (exibirBanner != null) {
            return exibirBanner;
        }
        return false;
    }
    
    /**
     * Carrega o contedo do atributo customizado para a pgina (layout) em relao a exibir ou no no submenu da pgina atual o Ttulo.
     * @param layout
     * @return boolean
     */
    private boolean getExibirTitulo(Layout layout) {
        Boolean exibirTitulo = (Boolean)layout.getExpandoBridge().getAttribute(ATRIBUTO_EXIBIR_TITULO);
        if (exibirTitulo != null) {
            return exibirTitulo;
        }
        return false;
    }
    
    
    
    /**
     * Carrega o contedo do atributo customizado para a pgina (layout) referente ao caminho da imagem do Banner.
     * @param layout
     * @return String
     */
    private String getImagemBanner(Layout layout) {
    	String imagem = Long.toString(layout.getIconImageId());
        if (imagem != null) {
            return imagem;
        }
        return "";
    }
    
    
    /**
     * Carrega o contedo do atributo customizado para a pgina (layout) referente ao caminho da imagem do Banner.
     * @deprecated
     * @param layout
     * @return String
     */
    private String getImagemBannerOld(Layout layout) {
    	String imagem = (String)layout.getExpandoBridge().getAttribute("imagem-banner");
        if (imagem != null) {
            return imagem;
        }
        return "";
    }
    
    /**
     * Carrega o contedo do atributo customizado para a pgina (layout) referente ao url do menu para a pagina.
     * @param layout
     * @return String
     */
    private String getLinkMenuPagina(Layout layout) {
    	String linkMenu = (String)layout.getExpandoBridge().getAttribute(ATRIBUTO_LINK_MENU_PAGINA);
        if (linkMenu != null) {
            return linkMenu;
        }
        return "";
    }
	
	/**
	 * Recupera o campo referente ao title html da pgina para ser utilizado na tag <a> na montagem do menu vertical.
	 * @param layout
	 * @return String - texto referente ao ttulo do menu ou null caso no tenha sido definido.
	 */
	private String getTitleHtmlMenu(Layout layout) {
		return (String)layout.getExpandoBridge().getAttribute(ATRIBUTO_TITLE_MENU);
		
		
	}
	
	/**
	 * Recuperar o valor do campo definido para a desativao ou no da funcinalidade do link pai de algum menu.
	 * @param layout
	 * @return boolean - true para desativar o link, false para ativar.
	 */
	private boolean isDesativarLinkPai(Layout layout) {
		Boolean desativar = (Boolean)layout.getExpandoBridge().getAttribute(ATRIBUTO_DESATIVAR_LINK_PAI);
		if (desativar != null) {
			return desativar;
		}
		return false;
	}
	
	/**
	 * Verifica se deve ocultar o ttulo do menu caso a pgina esteja configurada para utilizar o layout MPRJ Consulta.
	 * @param rootLayout
	 * @return boolean
	 */
	private boolean ocultarTituloMenu(Layout rootLayout) {
		String nomeLayout = rootLayout.getTypeSettingsProperties().get(LAYOUT_CONSULTA_KEY);
		if (nomeLayout != null 
				&& nomeLayout.equals(LAYOUT_CONSULTA_ID)) {
			return true;
		}
		return false;
	}
	
	/**
	 * Retorna apenas os layouts que no estejam escondidos.
	 * 
	 * @param filhos
	 * @return List&lt;Layout&gt;
	 */
	private List<Layout> getChildrenVisible(List<Layout> filhos) {
		List<Layout> listRet = new ArrayList<Layout>();
		if (filhos != null && filhos.size() > 0) {
			for (Layout layout : filhos) {
				if (!layout.isHidden()) {
					listRet.add(layout);
				}
			}
		}
		return listRet;
	}
	
	/**
	 * Retorna os Layouts filhos considerando ou no o nvel de permisses de exibio.
	 * @param themeDisplay - referncia ao theme display para obter o recurso de verificao da permisso
	 * @param layoutPai - layout pai (root) no qual retornar os filhos (children)
	 * @param utilizarPermissao - boolean indicando se deve ou no utilizar a verificao de permisso dos filhos (permissionchecker)
	 * @return List&lt;Layout&gt;
	 * @throws SystemException
	 * @throws PortalException
	 */
	private List<Layout> getChildrenPermissao(ThemeDisplay themeDisplay, Layout layoutPai, boolean utilizarPermissao) throws SystemException, PortalException {
		if (utilizarPermissao) {
			return layoutPai.getChildren(themeDisplay.getPermissionChecker());
		}
		else {
		    System.out.println("NO utilizar permisso");
			return layoutPai.getChildren();
		}
	}
}